<template>
    <RouterLink v-if="link" :to="to!" :class="buttonClass">
        <slot></slot>
    </RouterLink>
    <button v-else :class="buttonClass" :disabled="disabled">
        <slot></slot>
    </button>
</template>

<script setup lang="ts">
import { computed } from 'vue';
import { RouteLocationRaw } from 'vue-router';

type ButtonType = 'primary' | 'success' | 'warning' | 'danger' | 'secondary' | 'default';

interface BaseButtonProps {
    mode?: ButtonType;
    flat?: boolean;
    link?: boolean;
    to?: RouteLocationRaw;
    disabled?: boolean;
}

const props = withDefaults(defineProps<BaseButtonProps>(), {
    mode: 'default',
    flat: false,
    link: false,
    disabled: false,
});

const buttonClass = computed(() => {
    let result = `btn ${props.flat ? props.mode + '-flat' : props.mode}`;

    if (props.link) {
        return `${result} btn-link ${props.disabled ? 'disabled' : props.mode + '-actions'}`;
    }

    return `${result} ${props.mode}-actions`;
});

</script>

<style scoped>
button {
    @apply font-semibold;
    @apply disabled:opacity-75 disabled:cursor-not-allowed disabled:transition-none;
}

.btn-link {
    @apply no-underline;
    @apply hover:scale-95;
}

.btn-link.disabled {
    @apply opacity-75 cursor-not-allowed;
    @apply hover:scale-100;
}

.flat {
    @apply bg-transparent;
}

.btn-link.default-actions {
    @apply hover:bg-slate-400 hover:border-slate-500 hover:text-white;
    @apply active:bg-slate-500 active:border-slate-600 active:text-white;
}

.default-actions {
    @apply enabled:hover:bg-slate-400 enabled:hover:border-slate-500 enabled:hover:text-white;
    @apply enabled:active:bg-slate-500 enabled:active:border-slate-600 enabled:active:text-white;
}

.default {
    @apply bg-neutral-500 border-neutral-600 text-white;
}

.default-flat {
    @apply border-neutral-600 text-neutral-800;
}

.btn-link.primary-actions {
    @apply hover:bg-blue-700 hover:border-blue-800 hover:text-white;
    @apply active:bg-blue-800 active:border-blue-900 active:text-white;
}

.primary-actions {
    @apply enabled:hover:bg-blue-700 enabled:hover:border-blue-800 enabled:hover:text-white;
    @apply enabled:active:bg-blue-800 enabled:active:border-blue-900 enabled:active:text-white;
}

.primary {
    @apply bg-blue-500 border-blue-600 text-white;
}

.primary-flat {
    @apply border-blue-600 text-blue-800;
}

.btn-link.success-actions {
    @apply hover:bg-emerald-700 hover:border-emerald-800 hover:text-white;
    @apply active:bg-emerald-800 active:border-emerald-900 active:text-white;
}

.success-actions {
    @apply enabled:hover:bg-emerald-700 enabled:hover:border-emerald-800 enabled:hover:text-white;
    @apply enabled:active:bg-emerald-800 enabled:active:border-emerald-900 enabled:active:text-white;
}

.success {
    @apply bg-emerald-500 border-emerald-600 text-white;
}

.success-flat {
    @apply border-emerald-600 text-emerald-800;
}

.btn-link.danger-actions {
    @apply hover:bg-red-700 hover:border-red-800 hover:text-white;
    @apply active:bg-red-800 active:border-red-900 active:text-white;
}

.danger-actions {
    @apply enabled:hover:bg-red-700 enabled:hover:border-red-800 enabled:hover:text-white;
    @apply enabled:active:bg-red-800 enabled:active:border-red-900 enabled:active:text-white;
}

.danger {
    @apply bg-red-500 border-red-600 text-white;
}

.danger-flat {
    @apply border-red-600 text-red-800;
}

.btn-link.warning-actions {
    @apply hover:bg-amber-700 hover:border-amber-800 hover:text-white;
    @apply active:bg-amber-800 active:border-amber-900 active:text-white;
}

.warning-actions {
    @apply enabled:hover:bg-amber-700 enabled:hover:border-amber-800 enabled:hover:text-white;
    @apply enabled:active:bg-amber-800 enabled:active:border-amber-900 enabled:active:text-white;
}

.warning {
    @apply bg-amber-500 border-amber-600 text-white;
}

.warning-flat {
    @apply border-amber-600 text-amber-800;
}

.btn-link.secondary-actions {
    @apply hover:bg-gray-700 hover:border-gray-800 hover:text-white;
    @apply active:bg-gray-800 active:border-gray-900 active:text-white;
}

.secondary-actions {
    @apply enabled:hover:bg-gray-700 enabled:hover:border-gray-800 enabled:hover:text-white;
    @apply enabled:active:bg-gray-800 enabled:active:border-gray-900 enabled:active:text-white;
}

.secondary {
    @apply bg-gray-500 border-gray-600 text-white;
}

.secondary-flat {
    @apply border-gray-600 text-gray-800;
}

</style>
